function [B RS_data] = Rotated_SR(trainX,trainY,obj)
%% Rotated Sparse Regression for Efficient Compression
%% min_B,R ||R^{T}*Y - B^{T}X||_{2}^{2} + lamda||B||_{1}
%% s.t.  R^{T}*R = I. 
%%Blessing of Dimensionality: High-dimensional Feature and Its Efficient
%%Compression for Face Verification, CVPR, 2013
R = I;
obj_val = zeros(bj.maxiters,1);
for i = 1:obj.maxiters

    hat_Y = R*trainY;
    %% min_B||hat_Y - B^{T}X||_{2}^{2} + lamda||B||_{1}    
    param.lambda = obj.lambda;
    param.lambda2 =  param.lambda * 1e-1;
    param.mode = 2;
    B = mexLasso(hat_Y, trainX, param);
    B = full(B);
    
    %% Compute the value of objective function
    obj_val(i) = norm(hat_Y-B'*trainX,2).^2 +  obj.lambda*norm(B,1);
    fprintf('The value of objective function in %d iters is %f \n',i,obj_val(i));
    if i>1
    err = abs(obj_val(i)-obj_val(i-1));
    end
    if err<obj.threshold
        continue ;
    end
     %% min_B||R^{T}*Y - B^{T}X||_{2}^{2}  s.t.  R^{T}*R = I. 
    T_matrix = hat_Y*trainX'*B;
    [U, ~, V] = svd(T_matrix);
    R = U*V';
 
end
RS_data = B*trainX;
