function  [trdata, tedata] = processingdata(traindata,testdata,lr_basis)

% processingdata reduces the dimsension of CLM by using learned basis 
%
% For  theoretical and technical details, please refer to the following paper:
%
% Qilong Wang, Peihua Li, Wangmeng Zuo, and Lei Zhang. Towards Effective
% Codebookless Model for Image Classification. Pattern Recognition, 2016.
% DOI: 10.1016/j.patcog.2016.03.004 
% 
% Please cite the paper above if you use the code:
%
% For questions,  please conact:  Qilong Wang  (Email:  qlwang at mail dot dlut dot edu dot cn), 
%                                               Peihua  Li (Email: peihuali at dlut dot edu dot cn) 
%
% The software is provided ''as is'' and without warranty of any kind,
% experess, implied or otherwise, including without limitation, any
% warranty of merchantability or fitness for a particular purpose.

allnum = length(lr_basis);
dprerspm = size(traindata,1)/allnum;

trdata = [];
tedata = [];

if allnum>1
                  
    for ii = 1:allnum
        lr_basisT = lr_basis{ii};
        Temp = traindata((ii-1)*dprerspm+1:ii*dprerspm,:);
        trdataT = bsxfun(@minus, Temp, lr_basisT.mu);
        trdataT = lr_basisT.proj*trdataT; 
        trdata = [trdata ; trdataT];

      
        Temp = testdata((ii-1)*dprerspm+1:ii*dprerspm,:);
        tedataT = bsxfun(@minus, Temp, lr_basisT.mu);
        tedataT = lr_basisT.proj*tedataT; 
        tedata = [tedata ; tedataT];

    end
                
else    
    trdata = bsxfun(@minus, traindata, lr_basis.mu);
    clear traindata; 
    trdata = lr_basis.proj*trdata; 

    tedata = bsxfun(@minus, testdata, lr_basis.mu);
    clear testdata;
    tedata = lr_basis.proj*tedata;      
end 

end