function [prms] = setprms(featextr)

prms = [];
prms.type = featextr.reduction;
switch featextr.reduction
    case 'PCA'
        prms.dim = featextr.redim;
        prms.dimprop = featextr.redimp;
        prms.dimprops = featextr.redimps;
    case 'WPCA'
        prms.dim = featextr.redim;
        prms.dimprop = featextr.redimp;
        prms.dimprops = featextr.redimps;
    case 'RP'
        prms.dim = featextr.redim;
        prms.dimprop = featextr.redimp;
        prms.dimprops = featextr.redimps;
    case 'LDA'
        prms.init = 'PCA';
        prms.dim = 128;
        prms.initdim = 512;
        prms.dimprop = 0.1;
        prms.dimprops = false;
    case 'RSR'
        prms.init = 'PCA';
        prms.dim = 128;
        prms.initdim = 512;
        prms.maxiters = 20;
        prms.threshold = 1e-6;
        prms.lambda = 1e-3;
        prms.dimprop = 0.1;
        prms.dimprops = false;
    case 'LRSVM'
        prms.init = 'PCA';
        prms.dim = featextr.redim;
        prms.initdim = 1024;
        prms.dimprop = featextr.redimp;
        prms.dimprops = featextr.redimps;
end