function exprs = plow_expriments(opt,subdir)

% plow_expriments set the parameters for expriments 
%
% For  theoretical and technical details, please refer to the following paper:
%
% Qilong Wang, Peihua Li, Wangmeng Zuo, and Lei Zhang. Towards Effective
% Codebookless Model for Image Classification. Pattern Recognition, 2016.
% DOI: 10.1016/j.patcog.2016.03.004 
% 
% Please cite the paper above if you use the code:
%
% For questions,  please conact:  Qilong Wang  (Email:  qlwang at mail dot dlut dot edu dot cn), 
%                                               Peihua  Li (Email: peihuali at dlut dot edu dot cn) 
%
% The software is provided ''as is'' and without warranty of any kind,
% experess, implied or otherwise, including without limitation, any
% warranty of merchantability or fitness for a particular purpose.

exprs = [];
if strcmp(opt,'15')==1
    exprs.image_dataset =  'scene_categories';   
    exprs.base_feature_dir     =  ['feature\' subdir];
    exprs.training_num_per_category = 100;
    exprs.base_image_dir = ['images\' exprs.image_dataset];
    exprs.kernel = 'linear'; % linear, poly, exp, gaussian
    exprs.n = 50;
    exprs.beta = 1e10; %2e-2;
    exprs.libsvm = 'oneVSall'; %'oneVSone'
    exprs.lc = 10;
elseif strcmp(opt,'101')==1
    exprs.image_dataset =  '101_ObjectCategories';   
    exprs.base_feature_dir     =  ['feature\' subdir];
    exprs.training_num_per_category = 30;
    exprs.base_image_dir = ['images\'  exprs.image_dataset];
    exprs.kernel = 'linear'; % linear, poly, exp, gaussian
    exprs.n = 50;
    exprs.beta = 2e-2;
    exprs.libsvm = 'oneVSall'; %'oneVSone'
    exprs.lc = 10;
elseif strcmp(opt,'256')==1
    exprs.image_dataset =  '256_ObjectCategories';   
    exprs.base_feature_dir     =  ['feature\' subdir];
    exprs.training_num_per_category = 30;
    exprs.base_image_dir = ['images\'  exprs.image_dataset];
    exprs.kernel = 'linear';
    exprs.libsvm = 'oneVSall'; %'oneVSone'
    exprs.lc = 10;
elseif strcmp(opt,'10')==1
    exprs.image_dataset =  'fmd';   
    exprs.base_feature_dir     =  ['feature\' subdir];
    exprs.training_num_per_category = 50;
    exprs.base_image_dir = ['images\' exprs.image_dataset];
    exprs.kernel = 'linear';
    exprs.libsvm = 'oneVSall'; %'oneVSone'
    exprs.lc = 10;
end