function feat_prms = plow_features(epx)

% plow_features sets the parameters for feature extraction 
%
% For  theoretical and technical details, please refer to the following paper:
%
% Qilong Wang, Peihua Li, Wangmeng Zuo, and Lei Zhang. Towards Effective
% Codebookless Model for Image Classification. Pattern Recognition, 2016.
% DOI: 10.1016/j.patcog.2016.03.004 
% 
% Please cite the paper above if you use the code:
%
% For questions,  please conact:  Qilong Wang  (Email:  qlwang at mail dot dlut dot edu dot cn), 
%                                               Peihua  Li (Email: peihuali at dlut dot edu dot cn) 
%
% The software is provided ''as is'' and without warranty of any kind,
% experess, implied or otherwise, including without limitation, any
% warranty of merchantability or fitness for a particular purpose.

feat_prms.raw_feature    =  epx{1,1}; % sift; esift; L2EMG; eL2EMG 
feat_prms.patch_size = [2 4 6 8]; 
feat_prms.step = 2;
feat_prms.feature_type    =  'gaussian'; % histogram; mean; cov; gaussian 
feat_prms.constrant = 1e-3;
feat_prms.constrantGaussian = 1e-16;
feat_prms.constrantdet = 1e-12;
feat_prms.maxImageSize = 1000; 
feat_prms.minImageSize = 50; 
feat_prms.spm = [1 2 4]; 
feat_prms.repartion = true; 
feat_prms.reduction = epx{1,3}; 
feat_prms.redim = epx{1,4};
feat_prms.maxiters = 1; 
feat_prms.redimp = 0.999; 
feat_prms.redimps = false;
feat_prms.embedding_pn = epx{1,2}; %% (0,1]   
feat_prms.embedding_beta = 1.0; %% [0,1]
feat_prms.norm = 'power'; %'l1', 'l2'
feat_prms.canSkip = 1; % 1