function  [RawD, RawF] = GenerateRawFea(I,feat_prms) 

if strcmp(feat_prms.raw_feature,'sift')==1
    
    enrichments = {};
    [RawD,RawF] = compute_shape_invariant_feats(I, 'really_dense_sift', {enrichments}, 'gray', [], feat_prms.step, feat_prms.patch_size);
    
elseif strcmp(feat_prms.raw_feature,'esift')==1
    
    enrichments = { 'colornames', 'xy_fullimg', 'scale_fullimg','entropy','grad'}; 
    [RawD,RawF] = compute_shape_invariant_feats(I,'really_dense_sift', {enrichments}, 'gray', [], feat_prms.step, feat_prms.patch_size);
    
elseif strcmp(feat_prms.raw_feature,'ehog')==1
    
    enrichments = {'rgb', 'hsv', 'lab', 'xy_fullimg', 'scale_fullimg'};
    [RawD,RawF] = compute_shape_invariant_feats(I,'really_dense_hog', {enrichments}, 'gray', [], feat_prms.step, feat_prms.patch_size);
    
elseif strcmp(feat_prms.raw_feature,'elbp')==1
    
    enrichments = {'rgb', 'hsv', 'lab', 'xy_fullimg', 'scale_fullimg'};
    [RawD,RawF] = compute_shape_invariant_feats(I,'really_dense_lbp', {enrichments}, 'gray', [], feat_prms.step, feat_prms.patch_size);
    
elseif strcmp(feat_prms.raw_feature,'L2ECM')==1
    
    [RawD, RawF] = computelocalfeat(I, feat_prms.patch_size(2)^2,feat_prms.step,'CM');
    
elseif strcmp(feat_prms.raw_feature,'L2EMG')==1
    
    [RawD, RawF] = computelocalfeat(I, feat_prms.patch_size(2)^2,feat_prms.step,'MG');
    
elseif strcmp(feat_prms.raw_feature,'eL2EMG')==1
    
    [RawD1, RawF1] = computelocalfeat(I, feat_prms.patch_size(2)^2,feat_prms.patch_size,'MG');
    enrichments = {'rgb', 'hsv', 'lab', 'xy_fullimg', 'scale_fullimg'};
    [RawD,RawF] = enrichments_feats(RawD1,RawF1,I,'L2EMG', {enrichments}, [], feat_prms.patch_size(2)^2);    
    
end