function [feats, frames, valid] = computelocalfeat(im, patchSize,gridSpacing,opt)
%function [] = computelocalfeat( im, gridSpacing, patchSize)
%
%Generate the dense grid of l2ecm/lecmg descriptors for each image

% Input:
% im
% gridSpacing: the spacing for the grid to be used when generating the l2ecm/lecmg descriptors
% patchSize: the patch size used for generating the l2ecm/lecmg descriptor




%%  Extract  local descriptors for input image

 % 2014.04.01           
 [siftArr im_mask   grid_x grid_y] = covcalculatornoncombination(im,patchSize, gridSpacing,   1,opt);  
 
[my mx] = size(im_mask);   
[y x]= find(im_mask == 0); 
len = length(x);

 %% check local log cov descriptors 2014-06-04 WQL using_mask_two
% [use_x use_y] = find(im_mask == 1,1,'first');
% if length(use_x) < 1
%    error('All local log-Euclidean covariance matrix descriptors are  ill conditioned !');
% end    
% bound = 2;
% if len >= 1
%     for k =1:len
%         lx = max(x(k)-bound,1);    
%         rx = min(x(k)+bound,mx);
%         ly = max(y(k)-bound,1);    
%         ry = min(y(k)+bound,my);
%         [use_idx use_idy] = find(im_mask(ly:ry,lx:rx) == 1,1,'first');
%         siftArr_t = siftArr(ly:ry,lx:rx,:);
%         use_len = length(use_idx);
%         if use_len >= 1
%           siftArr(y(k),x(k),:) =  siftArr_t(use_idx,use_idy,:); 
%         else
%           siftArr(y(k),x(k),:) =  siftArr(use_x,use_y,:);   
%         end
%     end
% end
%%%%% check end

 siftArr = reshape(siftArr, size(siftArr, 1) * size(siftArr, 2), size(siftArr, 3));
 siftArr = sign(siftArr) .* abs(siftArr).^0.5;
 [gridX, gridY] = meshgrid(grid_x, grid_y);
 features.x = gridX(:);
 features.y = gridY(:);
 features.mask = im_mask(:);
 features.data =siftArr;
 features.data = bsxfun(@rdivide, features.data, max(sqrt(sum(features.data .^2, 2)), eps(2)));
 
 valid = len/length(im_mask(:));
 %% 2014-06-03 WQL using_mask_one
 KK = repmat(features.mask,[1 size(features.data,2)]);
 features.data = features.data.*double(KK);
 
 feats = features.data';
%  frames  = [features.x features.y];
%  frames = frames';
 
 sc = patchSize.*ones(size(features.x,1),1);
 frames  = [features.x features.y sc];
 frames = frames';
 
  %%  2014-06-04 WQL using_mask_three
% feats = feats(:,features.mask==1);
% frames = frames(:,features.mask==1);
end