function [sift_logP,sift_cov_mask, grid_x, grid_y] = dense_cov_MG(I_orientation, patch_size, grid_spacing)


[hgt wid num_angles] = size(I_orientation);
num_bins = patch_size;

grid_x = patch_size/2:grid_spacing:wid-patch_size/2;
grid_y = patch_size/2:grid_spacing:hgt-patch_size/2;

% Sample SIFT bins at valid locations (without boundary artifacts)
% find coordinates of sample points (bin centers)
[sample_x, sample_y] = meshgrid(linspace(1,patch_size+1,num_bins+1));
sample_x = sample_x(1:num_bins,1:num_bins); sample_x = sample_x(:)-patch_size/2;
sample_y = sample_y(1:num_bins,1:num_bins); sample_y = sample_y(:)-patch_size/2;


sift_arr = zeros([length(grid_y) length(grid_x) num_angles*num_bins*num_bins]);
sift_logP = zeros([length(grid_y) length(grid_x) (num_angles+1)*(num_angles+1)]);
%sift_arr = zeros([length(grid_y) length(grid_x) num_angles*num_bins*num_bins]);
b = 0;
for n = 1:num_bins*num_bins
    sift_arr(:,:,b+1:b+num_angles) = I_orientation(grid_y+sample_y(n), grid_x+sample_x(n), :);
    b = b+num_angles;
end


%lph:2013.10.01
sift_u= zeros([length(grid_y) length(grid_x) (num_angles)]);
sift_cov= zeros([length(grid_y) length(grid_x) (num_angles), (num_angles)]);

one_pixel_data = zeros(num_angles*num_bins*num_bins,1);
one_pixel_mat  = zeros(num_angles, patch_size*patch_size);
data_cov       = zeros(num_angles, num_angles);
sift_cov_mask  = zeros([length(grid_y) length(grid_x)],'uint8');

d = num_angles;
U0 = zeros(d, d);
S0 = U0;
V0 = U0;


U = zeros(d+1, d+1);
S = U;
V = U;
P = U;
logP = U;
diag_S = zeros(d+1, 1);

daig_S0 = zeros(d, 1);

constrain =  1e-12 ; %%%%%% WQL 2014-06-04 more strictly bound   1e-12  1e-8 eps(4)

for y=1:size(sift_arr,1)
    for x=1:size(sift_arr,2)
        one_pixel_data = squeeze(sift_arr(y,x,:));
        one_pixel_mat  = reshape(one_pixel_data,num_angles, patch_size*patch_size);

        one_pixel_mat = one_pixel_mat'; 
        data_cov       = cov(one_pixel_mat);
        data_u = mean(one_pixel_mat);
        
        %2014.04.18  ?
%         valid_flag = (length(find(diag(data_cov)>constrain)) == d);%%%%%% WQL 2014-06-04 more strictly bound
%         if valid_flag == 0
%             continue;
%         else
%             data_cov = data_cov ./ sqrt(diag(data_cov) * diag(data_cov)');
%         end
%         
%         [U0 S0 V0] = svd(data_cov);      %%%%phl
%         P(1:d, 1:d)  = U0 * diag(sqrt(diag(S0))) * V0';  
%         P(1:d, d+1) = data_u;
%         P(d+1, 1:d) = 0;
%         P(d+1, d+1) = 1;
        
%         %[U0 S0 V0] = svd(data_cov);
%         %data_cov = U0*diag(diag(S0)+eps(2)) * V0';
%         [U0 p]= chol(data_cov);
%         if p > 0
%             sift_cov_mask(y, x) = 1;
%             %sift_logP(y,x,:)  =  zeros((d+1)*(d+1),1);
%             continue;
%         end
%         P(1:d, 1:d) = U0;
%         P(1:d, d+1) = data_u;
%         P(d+1, d+1) = 1;
%         %logP = P;
%         logP = logm(P);

        P = ones(d+1);    %%%WQL 2014-7-15
        P(1:d, 1:d) = data_cov + data_u' * data_u; 
        P(1:d, d+1) = data_u;
        P(d+1, 1:d) = data_u';
        const = max(det(P),constrain)^(-1/(d+1));
        P =  const.*P;
  
        [U S V] = svd(P);
        diag_S = diag(S);
        valid_flag = (length(find(diag_S>constrain)) == (d+1)); %%%%%% WQL 2014-06-04 more strictly bound   1e-12  1e-8 eps(4)
        sift_cov_mask(y, x) = valid_flag;
        if valid_flag 
            logP = U*diag(log(diag_S))*U';
        else
            logP = U*diag(log(max(diag_S, constrain)))*U';  %%%%%% WQL 2014-06-04 more strictly bound
        end
        
%         % edit by WQL 2013/5/15
%         P = ones(d+1);
%         P(1:d, 1:d) = data_cov + data_u' * data_u; 
%         P(1:d, d+1) = data_u;
%         P(d+1, 1:d) = data_u';
%         %const = det(P)^(-1/(d+1));
%         %P =  const.*P;
%         [U S V]=svd( P);
% %         diag_S=diag(S);
% %         idx = find(diag_S>1e-16);
% %         sift_cov_mask(y,x) = length(idx);
% %         if length(idx) < num_angles+1
% %             diag_S = diag_S + 1e-12;
% %         end
%          logP = U*diag(log(diag(S)+eps(1/2)))*V';
         
        sift_logP(y,x,:)  =  logP(:);
        % lph:2013.10.01
        %sift_u(y, x, :)     =  data_u;
        %sift_cov(y, x, :, :) =  data_cov;
    end
end

%sift_cov_mask.u = sift_u;
%sift_cov_mask.cov = sift_cov;
%oneD_sift_cov = reshape(sift_cov,size(sift_cov,1)*size(sift_cov,2), size(sift_cov,3));
one_pixel_data = [];
one_pixel_mat  = [];
data_cov          = [];



